/*
 * Created by SharpDevelop.
 * User: Stephen
 * Date: 3/14/2009
 * Time: 4:30 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace UsingInterfaces
{
	public interface IMyBaseInterface
	{
		void DoSomethingBasic();
	}
	
	public interface IMyInterface : IMyBaseInterface
	{
		void DoSomethingOrOther();
		byte Version{get;}
	}

	public interface IMyUpdatedInterface : IMyInterface
	{
		void DoSomethingNew();
	}
	
	public interface IMyCompletelyNewInterface
	{
		void DoSomethingCompletelyNew();
	}
	
	class MainClass : IMyUpdatedInterface
	{
		public void DoSomethingOrOther()
		{
			Console.WriteLine("Now doing something");
			Console.ReadLine();
		}
		
		public byte Version
		{
			get { return 1;}
		}
		
		public void DoSomethingNew()
		{
			Console.WriteLine("Now doing something new");
			Console.ReadLine();
		}
		
		public void DoSomethingBasic()
		{
			Console.WriteLine("Now doing something basic");
			Console.ReadLine();
		}
		
		public static void Main(string[] args)
		{
			Console.WriteLine("Hello World!");
			MainClass mainClass = new MainClass();
			mainClass.DoSomethingOrOther();
			mainClass.DoSomethingBasic();
			Console.WriteLine("Version data: {0}", mainClass.Version);
			
			IMyBaseInterface iMyBaseInterface;
			iMyBaseInterface = mainClass;
			iMyBaseInterface.DoSomethingBasic();
			
			mainClass.DoSomethingNew();
			
			IMyUpdatedInterface iUpdatedIf = mainClass as IMyUpdatedInterface;
			
			if (iUpdatedIf != null)
			{
				Console.WriteLine("Interface is supported");
				iUpdatedIf.DoSomethingBasic();
			}
	        else
	        	Console.WriteLine("Interface not supported");
	        
	        IMyUpdatedInterface iUpdatedIf1 = mainClass;
	        if (iUpdatedIf1 is IMyUpdatedInterface)
			{
				Console.WriteLine("This interface is also supported");
				iUpdatedIf.DoSomethingBasic();
			}
	        else
	        	Console.WriteLine("Interface not supported");
	        
	        IMyCompletelyNewInterface iItf = (IMyCompletelyNewInterface) mainClass;
		}
	}
}
